image: docker:20.10.6

services:
  - docker:dind

variables:
  EVENTSTORE_TAG: $CI_REGISTRY_IMAGE/eventstore:release-5.0.8
  MONGO_TAG: $CI_REGISTRY_IMAGE/mongo:4.4.6
  POSTGRES_TAG: $CI_REGISTRY_IMAGE/postgres:13.3-alpine
  ELASTICSEARCH_TAG: $CI_REGISTRY_IMAGE/elasticsearch:7.13.1
  KIBANA_TAG: $CI_REGISTRY_IMAGE/kibana:7.13.1
  NETSHOOT_TAG: $CI_REGISTRY_IMAGE/netshoot:latest
  NODE14_TAG: $CI_REGISTRY_IMAGE/node:14.17.0-alpine
  NODE16_TAG: $CI_REGISTRY_IMAGE/node:16.14.2-alpine
  NODE14_TS_ES_TAG: $CI_REGISTRY_IMAGE/node-ts-eslint:14.17.0-alpine
  PROMETHEUS_TAG: $CI_REGISTRY_IMAGE/prometheus:v2.27.1
  METRICBEAT_TAG: $CI_REGISTRY_IMAGE/metricbeat:7.13.1
  DOCKER_TAG: $CI_REGISTRY_IMAGE/docker:20.10.6
  UBUNTU_TAG: $CI_REGISTRY_IMAGE/ubuntu:20.04
  NGINX_TAG: $CI_REGISTRY_IMAGE/nginx:1.20.0-alpine
  OPENJDK_JDK_TAG: $CI_REGISTRY_IMAGE/openjdk:11-jdk-slim
  OPENJDK_JRE_TAG: $CI_REGISTRY_IMAGE/openjdk:11-jre-slim
  MAVEN_JAVA11_TAG: $CI_REGISTRY_IMAGE/maven:3.8.3-openjdk-11-slim
  PYTORCH_TAG: $CI_REGISTRY_IMAGE/pytorch:1.6.0-cuda10.1-cudnn7-devel
  PYTORCH1_12_TAG: $CI_REGISTRY_IMAGE/pytorch:1.12.1-cuda11.3-cudnn8-runtime
  PYTORCH1_13_TAG: $CI_REGISTRY_IMAGE/pytorch:1.13.0-cuda11.6-cudnn8-devel
  PYTHON_TAG: $CI_REGISTRY_IMAGE/python:3.7-bullseye
  REDIS_TAG: $CI_REGISTRY_IMAGE/redis:6.2.6
  DDNS_TAG: $CI_REGISTRY_IMAGE/docker-ddns:latest
  CERTBOT_TAG: $CI_REGISTRY_IMAGE/certbot:v1.22.0
  DB_BACKUP_TAG: $CI_REGISTRY_IMAGE/db-backup:2.11.0
  TRAEFIK_TAG: $CI_REGISTRY_IMAGE/traefik:v2.6.1
  MINIO_TAG: $CI_REGISTRY_IMAGE/minio:RELEASE.2022-04-01T03-41-39Z
  ALPINE_TAG: $CI_REGISTRY_IMAGE/alpine:3.16.2

stages:
  - push

mongo:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "mongo"
    - docker pull mongo:4.4.6
    - docker tag  mongo:4.4.6 $MONGO_TAG
    - docker push $MONGO_TAG

eventstore:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "eventstore"
    - docker pull eventstore/eventstore:release-5.0.8
    - docker tag eventstore/eventstore:release-5.0.8 $EVENTSTORE_TAG
    - docker push $EVENTSTORE_TAG

postgres:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "postgres"
    - docker pull postgres:13.3-alpine
    - docker tag postgres:13.3-alpine $POSTGRES_TAG
    - docker push $POSTGRES_TAG

elasticsearch:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "elasticsearch"
    - docker pull docker.elastic.co/elasticsearch/elasticsearch:7.13.1
    - docker tag docker.elastic.co/elasticsearch/elasticsearch:7.13.1 $ELASTICSEARCH_TAG
    - docker push $ELASTICSEARCH_TAG

kibana:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "kibana"
    - docker pull docker.elastic.co/kibana/kibana:7.13.1
    - docker tag docker.elastic.co/kibana/kibana:7.13.1 $KIBANA_TAG
    - docker push $KIBANA_TAG

netshoot:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "netshoot"
    - docker pull nicolaka/netshoot:latest
    - docker tag nicolaka/netshoot:latest $NETSHOOT_TAG
    - docker push $NETSHOOT_TAG

node:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "node"
    - docker pull node:14.17.0-alpine
    - docker tag node:14.17.0-alpine $NODE14_TAG
    - docker push $NODE14_TAG
    - docker pull node:16.14.2-alpine    
    - docker tag node:16.14.2-alpine $NODE16_TAG
    - docker push $NODE16_TAG

ts-eslint:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "ts eslint"
    - docker build -t $NODE14_TS_ES_TAG node-ts-eslint
    - docker push $NODE14_TS_ES_TAG

prometheus:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "prometheus"
    - docker pull prom/prometheus:v2.27.1
    - docker tag prom/prometheus:v2.27.1 $PROMETHEUS_TAG
    - docker push $PROMETHEUS_TAG

metricbeat:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "metricbeat"
    - docker pull docker.elastic.co/beats/metricbeat:7.13.1
    - docker tag docker.elastic.co/beats/metricbeat:7.13.1 $METRICBEAT_TAG
    - docker push $METRICBEAT_TAG

docker:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "docker"
    - docker pull docker:20.10.6
    - docker tag docker:20.10.6 $DOCKER_TAG
    - docker push $DOCKER_TAG

ubuntu:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "ubuntu"
    - docker pull ubuntu:20.04
    - docker tag ubuntu:20.04 $UBUNTU_TAG
    - docker push $UBUNTU_TAG

nginx:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "nginx"
    - docker pull nginx:1.20.0-alpine
    - docker tag nginx:1.20.0-alpine $NGINX_TAG
    - docker push $NGINX_TAG

openjdk-jdk:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "openjdk-jdk"
    - docker pull openjdk:11-jdk-slim
    - docker tag openjdk:11-jdk-slim $OPENJDK_JDK_TAG
    - docker push $OPENJDK_JDK_TAG

openjdk-jre:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "openjdk-jre"
    - docker pull openjdk:11-jre-slim
    - docker tag openjdk:11-jre-slim $OPENJDK_JRE_TAG
    - docker push $OPENJDK_JRE_TAG

maven:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "maven:3.8.3-openjdk-11-slim"
    - docker pull maven:3.8.3-openjdk-11-slim
    - docker tag maven:3.8.3-openjdk-11-slim $MAVEN_JAVA11_TAG
    - docker push $MAVEN_JAVA11_TAG

pytorch:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "pytorch"
    - docker pull pytorch/pytorch:1.6.0-cuda10.1-cudnn7-devel
    - docker tag pytorch/pytorch:1.6.0-cuda10.1-cudnn7-devel $PYTORCH_TAG
    - docker push $PYTORCH_TAG

pytorch1_13:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "pytorch"
    - docker pull pytorch/pytorch:1.13.0-cuda11.6-cudnn8-devel
    - docker tag pytorch/pytorch:1.13.0-cuda11.6-cudnn8-devel $PYTORCH1_13_TAG
    - docker push $PYTORCH1_13_TAG

pytorch1_12:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "pytorch"
    - docker pull pytorch/pytorch:1.12.1-cuda11.3-cudnn8-runtime
    - docker tag pytorch/pytorch:1.12.1-cuda11.3-cudnn8-runtime $PYTORCH1_12_TAG
    - docker push $PYTORCH1_12_TAG

python:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "python"
    - docker pull python:3.7-bullseye
    - docker tag python:3.7-bullseye $PYTHON_TAG
    - docker push $PYTHON_TAG

redis:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "redis"
    - docker pull redis:6.2.6
    - docker tag redis:6.2.6 $REDIS_TAG
    - docker push $REDIS_TAG

ddns:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "ddns"
    - docker pull davd/docker-ddns:latest
    - docker tag davd/docker-ddns:latest $DDNS_TAG
    - docker push $DDNS_TAG

certbot:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "certbot"
    - docker pull certbot/certbot:v1.22.0
    - docker tag certbot/certbot:v1.22.0 $CERTBOT_TAG
    - docker push $CERTBOT_TAG

db-backup:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "db-backup"
    - docker pull tiredofit/db-backup:2.11.0
    - docker tag tiredofit/db-backup:2.11.0 $DB_BACKUP_TAG
    - docker push $DB_BACKUP_TAG

traefik:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "traefik"
    - docker pull traefik:v2.6.1
    - docker tag traefik:v2.6.1 $TRAEFIK_TAG
    - docker push $TRAEFIK_TAG

minio:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "minio"
    - docker pull quay.io/minio/minio:RELEASE.2022-04-01T03-41-39Z
    - docker tag quay.io/minio/minio:RELEASE.2022-04-01T03-41-39Z $MINIO_TAG
    - docker push $MINIO_TAG

alpine:
  stage: push
  when: manual
  before_script:
    - docker login $CI_REGISTRY
  script:
    - echo "alpine"
    - docker pull alpine:3.16.2
    - docker tag alpine:3.16.2 $ALPINE_TAG
    - docker push $ALPINE_TAG
